package template

import (
	"io"

	"github.com/GeertJohan/go.rice"
	"github.com/flosch/pongo2"
)

type loader struct {
	ricebox *rice.Box
}

func (loader) Abs(base, name string) string {
	return name
}

func (l loader) Get(path string) (io.Reader, error) {
	return l.ricebox.Open(path)
}

func New(debug bool) *Renderer {
	l := loader{
		ricebox: rice.MustFindBox("views"),
	}
	set := pongo2.NewSet("wiki", l)
	set.Debug = debug
	return &Renderer{
		set:  set,
	}
}

type Renderer struct {
	set   *pongo2.TemplateSet
}

func (r *Renderer) Render(w io.Writer, name string, data interface{}) error {
	t ,e := r.set.FromCache(name)
	if e != nil {
		return e
	}
	return t.ExecuteWriter(pongoContext(data), w)
}

func pongoContext(data interface{}) pongo2.Context {
	if ctx, ok := data.(map[string]interface{}); ok {
		return ctx
	}
	return nil
}